#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>

#define MISTNACISLO 3
#define MINCISLO 1
#define MAXCISLO 10
#define POCETCISEL 15


int VygenerujCislo(int minCislo, int maxCislo) {
	return rand() % (maxCislo-minCislo+1) + minCislo;
}

void VypisCisla(int *pole, int pocet) {
	int i;
	printf("\n");
	for (i=0; i< pocet; i++) {
		printf("%*d", MISTNACISLO, pole[i]);
	}
}

int *NaplnPole(int *pole, int pocet, int minCislo, int maxCislo) {
	int i;
	if (pole==NULL) {
		pole=(int*) malloc(sizeof(int)*pocet);
	}
	for (i=0; i<pocet; i++) {
		pole[i]=VygenerujCislo(minCislo, maxCislo);
	}
	return pole;
}

void BubbleSort(int *pole, int pocet) {
	int pom;
	int i; // index praveho prvku z dvojice
	int p; //pocet prvku na trideni
	for (p=pocet; p>1; p--) {
		for (i=1; i<p; i++) {
			if (pole[i]<pole[i-1]) {
				pom= pole[i];
				pole[i]=pole[i-1];
				pole[i-1]=pom;
			}
		}
	}
}

void QuickSort(int *pole, int pocet) {
	int pivot, pom;
	int l, p, ip;
	if (pocet <= 1) return;
	// pivota vezmu z prostredka posloupnosti
	ip=pocet/2;
	pivot=pole[ip];
	// pivot na 0tou pozici
	pole[ip]=pole[0];
	pole[0]=pivot;
	// poslopnost rozdelim na levou a pravou cast, 
	// v leve mensi ci rovny pivotu, v prave vetsi nez pivot
	l=1; p=pocet-1;
	while (l<p) {
		// najdu prvek, nepatrici do leve casti
		while (l<p && pole[l]<=pivot) l++;
		// najdu prvek, nepatrici do prave casti
		while (l<p && pole[p]> pivot) p--;
		// prohodim je
		pom = pole[l];
		pole[l]=pole[p];
		pole[p]=pom;
	} 
	// zde plati, ze l==p
	// zajistim aby prvek na pozici l patril do prave casti
	if (pole[l]<pivot) {
		pole[0]=pole[l];
		pole[l]=pivot;
	}
	// zavolam QS na levou a pravou cast
	QuickSort(pole, l);
	QuickSort(pole+l, pocet-l);
}

int *MergeSort(int *pole, int pocet) {
	int Li, Pi, i, Lpocet, Ppocet;
	int *V, *L, *P;
	// osetrime mozne chybne vstupni parametry
	if (pocet < 1 || pole==NULL) {
		return NULL;
	}
	// pokud jen jeden prvek, alokujeme pro nej misto a ukoncime funkci
	if (pocet==1) {
		V=(int*)malloc(sizeof(int));
		*V= *pole;
		return V;
	}
	// jinak rozpulime posloupnost a zavolame MS na levou a pravou polovinu
	Lpocet=pocet/2;
	Ppocet=pocet-Lpocet;
	L=MergeSort(pole,Lpocet);
	P=MergeSort(pole+Lpocet, Ppocet);
	// a ted budeme panovat ;o) -> sloucime dve setrizene posloupnosti
	i=0; Li=0; Pi=0;
	V=(int*) malloc(pocet*sizeof(int));
	while (i<pocet) {
		// do vysledneho pole prvky z leve posloupnosti
		while (Li<Lpocet && (L[Li]<=P[Pi] || Pi >= Ppocet)) {
			V[i++]=L[Li++];
		}
		// do vysledneho pole prvky z prave posloupnosti
		while (Pi<Ppocet && (P[Pi]<=L[Li] || Li >= Lpocet)) {
			V[i++]=P[Pi++];
		}
	}
	// uvolnime prostor alokovany pro levou a pravou posloupnost
	free(L);
	free(P);
	// vratime nove vytvorenou setrizenou posloupnost
	return V;
}

int *VytvorKopii(int *pole, int pocet) {
	int i;
	int *kopie;
	kopie=(int*) malloc(sizeof(int) * pocet);
	for (i=0; i< pocet; i++) {
		kopie[i]=pole[i];
	}
	return kopie;
}

void randomize() {
	time_t cas;
	srand((unsigned)time(&cas));
}

int main() {
	int *original, *kopie;
	randomize();
	original=NaplnPole(NULL,POCETCISEL,MINCISLO, MAXCISLO);
	printf("\nOriginal:");
	VypisCisla(original, POCETCISEL);
	// bubble sort
	kopie=VytvorKopii(original,POCETCISEL);
	BubbleSort(kopie, POCETCISEL);
	printf("\nBubbleSort:");
	VypisCisla(kopie, POCETCISEL);
	free(kopie);
	// quicksort
	kopie=VytvorKopii(original, POCETCISEL);
	QuickSort(kopie, POCETCISEL);
	printf("\nQuickSort:");
	VypisCisla(kopie, POCETCISEL);
	free(kopie);
	// MergeSort
	kopie=MergeSort(original, POCETCISEL);
	printf("\nMergeSort:");
	VypisCisla(kopie, POCETCISEL);
	free(kopie);
	// ukonceni
	free(original);
	printf ("\n ... stiskni klavesu pro ukonceni ...");
	getch();
	return 0;
}